# EnginePreviewWindow Struct Reference

Inheritance diagram for EnginePreviewWindow:

## Public Member Functions
| EnginePreviewWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
## Static Public Attributes
static const int | VEHICLE_SPACE = 40

## Detailed Description

Definition at line 66 of file engine_gui.cpp.

## Member Function Documentation

virtual void EnginePreviewWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 90 of file engine_gui.cpp.

References DrawString(), DrawStringMultiLine(), DrawVehicleEngine(), EPW_QUESTION, FONT_HEIGHT_NORMAL, GetEngineCategoryName(), GetEngineInfoString(), GetEnginePalette(), GetStringHeight(), SA_CENTER, SetDParam(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_PAR_VSEP_WIDE.

virtual void EnginePreviewWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 109 of file engine_gui.cpp.

References CMD_WANT_ENGINE_PREVIEW, DoCommandP(), EPW_NO, and EPW_YES.

virtual void EnginePreviewWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 74 of file engine_gui.cpp.

References Window::DrawWidgets().

virtual void EnginePreviewWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 79 of file engine_gui.cpp.

References EPW_QUESTION, FONT_HEIGHT_NORMAL, GetEngineCategoryName(), GetEngineInfoString(), GetStringHeight(), SetDParam(), and WD_PAR_VSEP_WIDE.

The documentation for this struct was generated from the following file:

- src/engine_gui.cpp